//**********************************************
//
//     SOLVisualizer_forANAPAW
//
//**********************************************
#include <fstream>
#include <iostream>
#include <string>
#include <png.h>
#include <stdio.h>
#include <stdlib.h>
//#include "png.h"
//#include <math.h>
#include <cmath>
#include <sstream>
#include <vector>
#include <boost/algorithm/string.hpp>
#include <map>
#include <algorithm>

#if defined(WIN32)
//#  pragma comment(linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"")
#  include "glut.h"
#  include "glext.h"
PFNGLPOINTPARAMETERFVPROC glPointParameterfv;
#elif defined(__APPLE__) || defined(MACOSX)
#  include <GLUT/glut.h>
#else
#  define GL_GLEXT_PROTOTYPES
#  include <GL/glut.h>
#endif

#include <GL/glui.h>
#include "trackball.h"





//----------- 各種外部変数 ---------------//

static std::string AppName ="SOLVisualizer for ANAPAW";
static std::string AppVer = "Ver 2011.8.22";
static std::string AppAuth = "by Takayuki Sako";


static std::map<int, std::string> ClusterMap; 
static std::map<int, int*> GateMap; 
static std::map<int, int> GateMaxMap; 


static int glutWinId;//ウィンドウID
static GLfloat black[] = { 0.0, 0.0, 0.0, 1.0 };
static GLfloat Cluster_color[][4] = {
  { 0.0, 1.0, 0.0, 0.5 },
  { 0.0, 1.0, 0.0, 0.5 },
  { 0.3, 0.3, 1.0, 0.5 },
  { 1.0, 1.0, 1.0, 0.5 },
  { 1.0, 0.67, 0.0, 0.5 },
  { 0.5, 0.5, 0.5, 0.5 },
  { 0.0, 1.0, 0.0, 0.5 },
};

static GLfloat color_Detector_trak[] = { 1.0, 0.0, 0.0, 1.0 };
static GLfloat color_All_track[] = { 1.0, 0.0, 0.0, 1.0 };
static int color_All_track_RGB[] = { 255, 0, 0, 1.0 };
static GLfloat Background[] = { 1.0, 1.0, 1.0, 1.0 };
static GLfloat Zaxis_color[] = { 0.8, 0.8, 0.2, 1.0 };


static GLfloat lit_amb[4]={0.3, 0.3, 0.3, 0.5};	/* 環境光の強さ */
static GLfloat lit_dif[4]={1.0, 1.0, 1.0, 0.5};	/* 拡散光の強さ */
static GLfloat lit_spc[4]={1.0, 1.0, 1.0, 0.5};	/* 鏡面反射光の強さ */
static GLfloat lit_pos[4]={100.0, 100.0, 100.0, 1.0};	/* 光源の位置 */

static GLfloat mat_amb[4]={0.2, 0.2, 0.2, 0.5};	/* 環境光に対する反射 */
static GLfloat mat_dif[4]={0.8, 0.8, 0.8, 0.5};	/* 拡散光に対する反射 */
static GLfloat mat_spc[4]={0.2, 0.2, 0.2, 0.5};	/* 鏡面反射 */
static GLfloat mat_emi[4]={0.0, 0.0, 0.0, 0.5};	/* 発光 */
static GLfloat mat_shi[1]={80.0};	/* 光沢 */

static GLfloat Particle_mat_amb[4]={1.0, 1.0, 1.0, 1.0};	/* 環境光に対する反射 */
static GLfloat Particle_mat_dif[4]={1.0, 1.0, 1.0, 1.0};	/* 拡散光に対する反射 */
static GLfloat Particle_mat_spc[4]={0.2, 0.2, 0.2, 1.0};	/* 鏡面反射 */
static GLfloat Particle_mat_emi[4]={1.0, 0.0, 0.0, 1.0};	/* 発光 */
static GLfloat Particle_mat_shi[1]={150.0};	/* 光沢 */

static float trans_ary[2]={0,0};
static float trans_aryZ[]={0};


 //マウスポインタの現在の座標を格納する大域変数
static int MouseX=500, MouseY=500;

static int Cluster_alpha[] = { 50, 50, 50, 50, 50, 50, 50 };
static int color_All_track_alpha = { 70 };
static int Zaxis_alpha = 70;


static int Cluster_list_SW[] = { 0, 0, 0, 0, 0, 0, 0 };
//static int listNEUT_SW = 0;


static int listParticle_SW = 1;
static int listParticle_SW_type = 0;
static GLfloat Particle_LineWidth = 1.0; 
static GLfloat Zaxis_LineWidth = 2.0;

static int Cluster_Outline[] = { 1, 1, 1, 1, 1, 1, 1 };

//static int outline_NEUT  = 1;

static int display_Particle = 1;
static int Cluster_display[] = { 1, 1, 1, 1, 1, 1, 1 };
//static int display_NEUT  = 1;

static int Cluster_RGB[][3] = {
  { 128,128, 255}, //dummy
  { 77,  77, 255},
  {  0, 255, 255},
  { 50, 100,   0},
  { 77,  77, 255},
  {128, 128, 128},
  { 77,  77, 255},
  { 77,  77, 255},
};
//static int RGB_NEUT[3] 
static int RGB_Background[3] = {255, 255, 255};
static int Zaxis_RGB[3] = {204,204,51};
static GLclampf RGB_BackgroundF[4];

static int check_Zbuffering = 1;
static int display_Information = 0;
static int check_Antialias_Line = 0;
static int check_Antialias_Polygon = 0;
static int check_Particle = 0;
static int check_Movie = 0;
static int check_DebugMode = 0;
static int check_AccGateNO = 1;
static int check_Zaxis = 1;
static float Zaxis_Cons = 1.0;


//for Windows
//static char filename[100];


//for Linux
static char *filename;
static std::string Filename;


static GLUI_EditText *editText;
static GLUI_String text_glui_str;
//static char pngname[18];
//static char *pngname;
static int pngNO = 101;



static int NO_Detector[5][4];
static int MAX_Detector = 999;
static int MAX_track ;
static int MAX_track_force = 5000;
static int All_MAX_track;
static int NO_NEUT = 60;
static int NO_NEUT_x = 30;
static int NO_NEUT_z = 2;
static int NO_VETO = 12;

static float** Detector_geo;
static char** Detector_shape;
static float** Detector_track;
static float** All_track;
static float* All_track_T;
static float** Track_sort;
static float** Particle_init;
static float** Particle_move;
static int** Track_GateList;
static int* Disp_GateList;
static int Disp_GateMAX;
static int Disp_CurrentGate = 0 ;
static int* EC_GateList;
static int* NO_GateList;
static int AccGateNO = 0 ; 
static GLfloat Particle_distance[3] = { 0.0, 0.0, 1.0 };
static GLfloat Particle_size;

static float GLUIver;
static char *GLUIver_cha;

static GLUI *Master_glui;
static GLUI *sub_glui;
static GLUI *about_glui;


static float curquat[4];  //現在のクォータニオン
static float lastquat[4]; //更新用のクォータニオン
static std::pair<int,int> WindowSize(1800,1000);
static std::pair<int,int> WindowPosi(50,50);
static int moving = 0;
static int beginx, beginy;
static float quatm[4][4];

extern void capture(const char *filepath,int Flag);

extern void MakeAbout(int num);
extern void gluiCallbackExit(int num);
extern void gluiCallbackPng(int num);
extern void initialize();
extern void display();
extern void load_file_config();
extern void myMouseFunc(int button,int state,int x,int y);
extern void myMouseMotion(int x,int y);
static void *font = GLUT_BITMAP_HELVETICA_12;
//static void *font = GLUT_BITMAP_TIMES_ROMAN_10;
//static void *font = GLUT_BITMAP_9_BY_15;
static void *font3D = GLUT_STROKE_ROMAN;
//static void *font3D = GLUT_STROKE_MONO_ROMAN
extern void DrawString(const char *str,void *font,float x,float y,float z);
extern void DrawString3D(const char *str,void *font3D,float Width);
extern void scene(void);
extern void MakeFilename(const char *RDFNAME, const char *ANAFNAME);


static float interval = 200000.0;
static float Particle_OFFSET = 1000.0;
static float interval_count = 0.0;
static float rend_time = 50.0;

static int GLframe = 0; //フレーム数
static int GLtimenow = 0;//経過時間
static int GLtimebase = 0;//計測開始時間
static float GL_FPS = 0; //フレーム数


static int SVA_ClusterNOMax;
static int SVA_ClusterNO[] = {1,1,1,1,1};
static int SVA_DetectorID[999];
static int SVA_DetectorClusterNO[999];
static int SVA_EventCounter[999999];
//static string SVA_ClusterName[99];
//static char *SVA_ClusterName[999][200];



//回転行列
//static float rotary[16] = {
//	1.0, 0.0, 0.0, 0.0,
//	0.0, 1.0, 0.0, 0.0,
//	0.0, 0.0, 1.0, 0.0, 
//	0.0, 0.0, 0.0, 1.0 };

//コマンドプロンプトを出さない 
#pragma comment(linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"") 




// from "http://homepage2.nifty.com/well/Stream.html"




////---------- フォントの描画 ------------//
void DrawString(const char *str,void *font,float x,float y,float z)
{
  glRasterPos2f(x, y); //左下が原点
  while(*str){
    glutBitmapCharacter(font, *str);
    ++str;
  }
}


void DrawString3D(const char *str,void *font3D,float Width)
{
  glPushAttrib(GL_LINE_BIT);
  glLineWidth(Width);
  while(*str){
    glutStrokeCharacter(font3D, *str);
    ++str;
  }
  glPopAttrib();
}


void FPS(int num){ 

  GLframe++; //フレーム数を＋１
  GLtimenow = glutGet(GLUT_ELAPSED_TIME);//経過時間を取得
  
  if (GLtimenow - GLtimebase > 500)      //１秒以上たったらfpsを出力
    {
      GL_FPS = GLframe*500.0/(GLtimenow-GLtimebase);
      //			printf("fps : %f \n",GLframe*500.0/(GLtimenow-GLtimebase));
      GLtimebase = GLtimenow;//基準時間を設定                
      GLframe = 0;//フレーム数をリセット
    }
  
  glutPostRedisplay(); 
  if(display_Information == 1){
    glutTimerFunc(rend_time , FPS , 0); 
  }
} 

std::string Int2String(int number)
{
  std::stringstream ss;
  ss << number;
  return ss.str();
}


void Init_Array(void){
	int DHM = 3000;
  MAX_track = 100000;
  All_MAX_track = 500;
  Detector_geo = new float*[MAX_Detector];
  Detector_shape = new char*[MAX_Detector];
  for (int i = 0 ; i < MAX_Detector ; i++){
    Detector_geo[i] = new float[6];
    Detector_shape[i] = new char[2];
  }
  Detector_track = new float*[MAX_track];
  All_track = new float*[MAX_track];
  Track_sort = new float*[MAX_track];
  Particle_init = new float*[MAX_track];
  Particle_move = new float*[MAX_track];
	Track_GateList = new int*[MAX_track];
  for (int i = 0 ; i < MAX_track ; i++){
    Detector_track[i] = new float[4];
    All_track[i] = new float[4];
    Track_sort[i] = new float[4];
    Particle_init[i] = new float[7];
    Particle_move[i] = new float[7];
		Track_GateList[i] = new int[DHM];
  }
	Disp_GateList = new int[DHM];
	All_track_T = new float[MAX_track];
	EC_GateList = new int[MAX_track];
	NO_GateList = new int[MAX_track];
}


void CB_NULL(void){
}


void myMouseFunc(int button,int state,int x,int y)
{
  if(button == GLUT_LEFT_BUTTON && state == GLUT_DOWN)
    {
      moving = 1;
      beginx = x;
      beginy = y;
    }
  
  if (button == GLUT_LEFT_BUTTON && state == GLUT_UP) 
    {
      moving = 0;
    }
}


void myMouseMotion(int x,int y)
{
  if (moving) 
    {
      //マウスの視点と終点からクォータニオンを計算する(-1～1の範囲に正規化した座標を指定する)
      trackball(lastquat,
		(2.0 * beginx - WindowSize.first) / WindowSize.first,
		(WindowSize.second - 2.0 * beginy) / WindowSize.second,
		(2.0 * x - WindowSize.first) / WindowSize.first,
		(WindowSize.second - 2.0 * y) / WindowSize.second
                );
      
      beginx = x;
      beginy = y;
      
      add_quats(lastquat, curquat, curquat);//クォータニオンを加算
    }
  glutPostRedisplay();
}




void initialize(int num){
  trans_ary[0]=0;
  trans_ary[1]=0;
  trans_aryZ[0]=0;
  trackball(curquat, 0.0, 0.0, 0.0, 0.0);
  display();
}

void key_x(int Flag){
  if (Flag == 0){
    trans_ary[0] = trans_ary[0] - 10.0;
  } else if (Flag == 1){
    trans_ary[0] = trans_ary[0] + 10.0;
  } 
  glutPostRedisplay();

}

void key_y(int Flag){
  if (Flag == 0){
    trans_ary[1] = trans_ary[1] - 10.0;
  } else if (Flag == 1){
    trans_ary[1] = trans_ary[1] + 10.0;
  } 
  glutPostRedisplay();
  
}

void key_z(int Flag){
  if (Flag == 0){
    trans_aryZ[0] = trans_aryZ[0] - 10.0;
  } else if (Flag == 1){
    trans_aryZ[0] = trans_aryZ[0] + 10.0;
  } 
  glutPostRedisplay();
  
}


void keyboard(unsigned char key, int x, int y)
{
  /* ESC か q をタイプしたら終了 */
  if (key == '\033' || key == 'q') {
    gluiCallbackExit(0);
  } else if (key == 'i'){
    initialize(0);
  } else if (key == 'p'){
    gluiCallbackPng(1);
  } else if (key == 'w'){
    key_z(1);
  } else if (key == 'a'){
    key_x(0);
  } else if (key == 's'){
    key_z(0);
  } else if (key == 'd'){
    key_x(1);
  }
  
}

void Specialkeyboard(int key, int x, int y)
{
  if (key == GLUT_KEY_UP ){
    key_z(1);
  } else if (key == GLUT_KEY_LEFT){
    key_x(0);
  } else if (key == GLUT_KEY_DOWN){
    key_z(0);
  } else if (key == GLUT_KEY_RIGHT){
    key_x(1);
  } else if (key == GLUT_KEY_PAGE_UP){
    key_y(1);
  } else if (key == GLUT_KEY_PAGE_DOWN){
    key_y(0);
  } 
}


//---------------- 物体 ---------------------------------//


void Information_FPS(char Info_FPS[100]){
	sprintf(Info_FPS, "fps : %f", GL_FPS);
}

void Information_mode(){
  char Info_FPS[100];
  //	//ここからフォント描画処理
  glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, black);
  glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, black);
  
  glPushMatrix(); //各種行列を退避
  glLoadIdentity();
  glMatrixMode(GL_PROJECTION); //2Dの並行投影を設定
  glPushMatrix();
  
  glLoadIdentity();
  gluOrtho2D(0, WindowSize.first, 0, WindowSize.second);
  //ここから描画
  glPushAttrib(GL_CURRENT_BIT|GL_DEPTH_BUFFER_BIT);  //色、Zバッファの退避
  glDisable(GL_DEPTH_TEST);
  DrawString("SOLVisualizer information",font,15,100,0);
  Information_FPS(Info_FPS);
  DrawString(Info_FPS,font,25,90,0);
  
  //			DrawString("glui ver : ",font,20,90,0);
  //			printf(" %s", GLUIver_cha);
  //			DrawString(GLUIver_cha,font,70,90,0);
  glPopAttrib();
  
  glPopMatrix(); 
  glMatrixMode(GL_MODELVIEW);
  glPopMatrix();//もとの状態にもどる
}


void CubeColor(int ID, int display,int list,int outline,GLfloat width, GLfloat *color){
  if (display == 1) {
    glPushMatrix();
    glMultMatrixf(&quatm[0][0] );
    //		glMultMatrixf( rotary );
    glTranslated(Detector_geo[ID][0] + trans_ary[0],
		 Detector_geo[ID][1] - trans_ary[1],
		 Detector_geo[ID][2] - trans_aryZ[0]);
    glScalef(Detector_geo[ID][3],Detector_geo[ID][4],Detector_geo[ID][5]);
    glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, color);
    glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, color);
    if (list == 1){
      glLineWidth(width);
      glutWireCube(1.0);
    }else{
      glutSolidCube(1.0);
      if(outline == 1){
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, black);
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, black);
	glLineWidth(width);
	glutWireCube(1.0);
      }
    }
    glPopMatrix();
  }
}

int GateCheck(int num){

	int *GateList;
	int GateMax;
	int i ;
	int GateFlag = 0;
	using namespace std;

	map<int, int*>::iterator itrGate = GateMap.begin();
	// キーから値を検索
	itrGate = GateMap.find(num);
	// マップが end では無い場合（つまりキーにヒットする値が存在した場合）
	if (itrGate != GateMap.end()) 
		{
			// 値取得
			GateList = itrGate->second;
		}

	map<int, int>::iterator itrMax = GateMaxMap.begin();
	// キーから値を検索
	itrMax = GateMaxMap.find(num);
	// マップが end では無い場合（つまりキーにヒットする値が存在した場合）
	if (itrMax != GateMaxMap.end()) 
		{
			// 値取得
			GateMax = itrMax->second;
		}
		
	for ( i = 0 ;  i <= GateMax ; i++ ){
		if (GateList[i] == Disp_CurrentGate){
			GateFlag = 1;
			break;
		}
	}

//	if (check_DebugMode == 1){
//		cout << num << "," ;
//		for (i = 0 ; i <= GateMax ; i ++ ){
//			cout 	<< GateList[i] << "," ;
//		}
//		cout << endl ;
//	}
	
	return GateFlag;

}

void DrawZaxis(){
	using namespace std;
		glPushMatrix();
		glMultMatrixf( &quatm[0][0] );
		glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, Zaxis_color);
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, Zaxis_color);
		glLineWidth(Zaxis_LineWidth);
		
		glBegin(GL_LINES);
		
		AccGateNO = 0;
		glVertex3f(0.0 +  trans_ary[0],
							 0.0 -  trans_ary[1],
							 -1000.0*Zaxis_Cons -  trans_aryZ[0]);
		glVertex3f(0.0 +  trans_ary[0],
							 0.0 -  trans_ary[1],
							 1000.0*Zaxis_Cons -  trans_aryZ[0]);
		glEnd();
		glPopMatrix();
}


void LineColor(int MAX, float **track,  GLfloat width, GLfloat *color){
	using namespace std;
		glPushMatrix();
		glMultMatrixf( &quatm[0][0] );
		glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, color);
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, color);
		glLineWidth(width);
		
		int PreEC= 0;
		int GateFlag;

		glBegin(GL_LINE_STRIP);
		
		AccGateNO = 0;
		
		
		for (int i = 0 ; i < SVA_EventCounter[MAX_track] ; i++) {
			if (SVA_EventCounter[i] != PreEC){
				glEnd();
				if (check_DebugMode == 1){
					cout << "------------------------"<<endl;
				}
				glBegin(GL_LINE_STRIP);
			}
			GateFlag = GateCheck(SVA_EventCounter[i]);
			if (GateFlag > 0 ){
				glVertex3f(track[i][0] +  trans_ary[0],
									 track[i][1] -  trans_ary[1],
									 track[i][2] -  trans_aryZ[0]);
				AccGateNO += 1;
				if (check_DebugMode == 1){
					cout << SVA_EventCounter[i] <<"," <<track[i][0] << "," 
							 << track[i][1] << "," << track[i][2] << "," << endl;
				}
			}
			PreEC = SVA_EventCounter[i];
		}
		glEnd();
		glPopMatrix();

		
		if (check_AccGateNO == 1){
			string AccStr,AccNO;
			AccNO = Int2String(AccGateNO);
			AccStr = "Gated particle : " + AccNO;
			DrawString(AccStr.c_str(),font,200,130,0);
		}	

}

void ColorConvert(int color[3],int alpha,float colorF[4]){
  for (int i = 0 ; i < 3 ; i++) {
    colorF[i] = color[i]/100.0;
  }
  colorF[3] = alpha/100.0;
}

void GLColorConvert(int color[3],int alpha,GLclampf colorF[4]){
  for (int i = 0 ; i < 3 ; i++) {
		colorF[i] = color[i]/100.0;
  }
  colorF[3] = alpha/100.0;
}


void geometry(void)
{
	int ID;
	int i, j;
	using namespace std;
	
	
	glTranslated(0.0, 0.0, -3.0);
	
	for ( i = 0 ; i < SVA_ClusterNOMax ; i++) {
		ColorConvert(Cluster_RGB[i],Cluster_alpha[i],Cluster_color[i]);
	}
	ColorConvert(color_All_track_RGB,color_All_track_alpha,color_All_track);
	
	glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, mat_spc);
	glMaterialfv(GL_FRONT_AND_BACK, GL_SHININESS, mat_shi);
	glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, mat_emi);
	for (ID = 0; ID < MAX_Detector ; ID++) {
		i = SVA_DetectorClusterNO[ID];
		CubeColor(ID,Cluster_display[i],Cluster_list_SW[i],Cluster_Outline[i],3.0,Cluster_color[i]);
		}
	
	if(display_Information == 1){
		FPS(0);
		Information_mode();
	}
	
	if (check_Particle == 1){
		LineColor(All_MAX_track,All_track,Particle_LineWidth,color_All_track);
		glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR,  Particle_mat_spc);
		glMaterialfv(GL_FRONT_AND_BACK, GL_SHININESS, Particle_mat_shi);
		glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION,  Particle_mat_emi);
	}
	
	if(check_Zaxis == 1){
		DrawZaxis();
	}


}



/*
 *	光源の初期化
 */
void init_light(void)
{
  glLightfv(GL_LIGHT0, GL_AMBIENT, lit_amb);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, lit_dif);
  glLightfv(GL_LIGHT0, GL_SPECULAR, lit_spc);
  glLightfv(GL_LIGHT0, GL_POSITION, lit_pos);
  
  /* ライトを有効にする */
  glEnable(GL_LIGHT0);
  glEnable(GL_LIGHTING);
}



//---------------- 各種コールバック ----------------------//

//ディスプレイのコールバック
void display(void) 
{
  
  /* モデルビュー変換行列の初期化 */
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  GLColorConvert(RGB_Background,100,RGB_BackgroundF);
  glClearColor(RGB_BackgroundF[0],RGB_BackgroundF[1],RGB_BackgroundF[2],RGB_BackgroundF[3]);
  
  
	
  build_rotmatrix(quatm, curquat);//クォータニオンから回転行列を作成する
  //	rotary = &quatm[0][0];
  
  
  //視点(5,5,5)から原点（0,0,0)の方向をy軸の正の方向(0,1,0)を頭上として見た視界
  gluLookAt(0.0, 0.0, -400.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);

  //		glColor3f(0,1,0);
  //        glPushMatrix();
  
  //アンチエリアシング
  if (check_Antialias_Line == 1){
    glEnable(GL_LINE_SMOOTH);	
  }else{
    glDisable(GL_LINE_SMOOTH);	
  }
  if (check_Antialias_Polygon == 1){
    glEnable(GL_POLYGON_SMOOTH);	
	}else{
    glDisable(GL_POLYGON_SMOOTH);	
  }
  glEnable(GL_POLYGON_OFFSET_FILL);
  glPolygonOffset(1.f, 1.f);
  glEnable(GL_DEPTH_TEST);
  
  
  if (check_Zbuffering == 0) {
    /* ブレンディングを有効にする */
    glEnable( GL_BLEND );
    /* デプスバッファへの書き込みを禁止する */
    glDepthMask( GL_FALSE );
    /* ブレンディングのための方程式を設定する */
    glBlendFunc( GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA );
    geometry();
    
    //scene();	
    
    //	glutTimerFunc(rend_time , anime , 0); // event 100msec
    
  } else {
    /* デプスバッファーへの書き込みを許可する */
    glDepthMask( GL_TRUE );
    /* ブレンディングを無効にする */
    glDisable( GL_BLEND );
    geometry();
    //	glutTimerFunc(rend_time , anime , 0); // event 100msec
    
  }
  
  glDisable(GL_POLYGON_OFFSET_FILL);
  glutSwapBuffers();
  if (check_Movie == 1){
    gluiCallbackPng(0);
  }
	
}




//void reshape(int w, int h)
void reshape(int w, int h)
{
  WindowSize.first = w;	
  WindowSize.second = h;	
  
  //GLUI_Master.get_viewport_area( &WindowPosi.first, &WindowPosi.second, 
  // &WindowSize.first, &WindowSize.second );
  //glViewport(WindowPosi.first, WindowPosi.second, 
  glViewport(0,0, WindowSize.first, WindowSize.second );
  
  Particle_size = WindowSize.first * 10.0 ;
  
  /* ライトの設定 */
  init_light();
  
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  //垂直方向の視野角を45°、視点からの距離が1.0〜100.0の範囲を可視領域に指定
  gluPerspective(45.0, (double)WindowSize.first / (double)WindowSize.second, 1.0, 50000.0);

}  
  //	gluPerspective(45.0, (double)tw / (double)th, 1.0, 50000.0);
  //glMatrixMode(GL_MODELVIEW);
  //  glMatrixMode(GL_PROJECTION);


//void alphachannel(int id){
//	float alpha ;
//	alpha =  id/100.0;
//	blue[] = { 0.0, 0.0, 1.0, alpha };
//}


//------------- OpenGLの初期設定 ------------------//
void GLUT_INIT()
{
  glutInitDisplayMode(GLUT_RGBA| GLUT_DOUBLE | GLUT_DEPTH);
  glutInitWindowPosition(WindowPosi.first,WindowPosi.second);
  glutInitWindowSize(WindowSize.first,WindowSize.second);
	{
		using namespace std;
		string windowname;
		windowname = AppName + " " + AppVer;
			glutWinId = glutCreateWindow(windowname.c_str());
	}
//	GLUIver = GLUI_Master.get_version();
  // sprintf( GLUIver_cha,"%f", GLUIver );
}


void GLUT_CALL_FUNC()
{
  //	glutDisplayFunc(display);//displayはglut
  //	glutIdleFunc(FPS);
  
  //trackball
  glutMotionFunc(myMouseMotion);

}

void MY_INIT()
{
  glClearColor(1.0, 1.0, 1.0, 1.0);
  glEnable(GL_CULL_FACE);
}



//--------- GLUTの初期設定 -----------//
void GLUT_INITs(int *argcp, char **argv)
{
	glutInit(argcp,argv);
	GLUT_INIT();
	GLUT_CALL_FUNC();
	MY_INIT();
}



void rotCB(int val)
{
  glutSetWindow(glutWinId);
  glutPostRedisplay();
}

//------ glui ----------//
void gluiCallbackExit(int num) {
  for (int i = 0 ; i < MAX_Detector ; i++){
    delete [] Detector_geo[i];
    delete [] Detector_shape[i];
  }
  for (int i = 0 ; i < MAX_track ; i++){
    delete [] Detector_track[i];
    delete [] All_track[i];
		delete [] Track_GateList[i];
  }
  delete [] Detector_geo;
  delete [] Detector_shape;
	delete All_track_T;
	delete [] Track_GateList;
	delete [] Disp_GateList;
  exit(0);
}



void gluiCallbackPng(int Flag) {
	using namespace std;
	string pngname,pngNO_str;
	
	pngNO_str = Int2String(pngNO);
	pngname = Filename + "_" + pngNO_str +".png";
//
//  sprintf(pngNOchar, "%d", pngNO);
//	cout << pngname << endl;
//
//  sprintf(pngname, "%s", Filename.c_str());
//	cout << pngname << endl;
//
//  strcat(pngname,"_");
//	cout << pngname << endl;
//
//  strcat(pngname,pngNOchar);
//  strcat(pngname,".png");
	cout << pngname << endl;
  capture(pngname.c_str(),Flag);
  ++pngNO;
}


void Spinner_set(GLUI_Spinner *Spinner,int speed,int min,int max,int init,int width){
  Spinner->set_speed(speed);//変化速度
  Spinner->set_int_limits(min,max,GLUI_LIMIT_CLAMP);//限界値とその処理
  Spinner->set_int_val(init);//初期値
  Spinner->set_w(width);
}

void Spinner_setF(GLUI_Spinner *Spinner, float speed, float min, float max, float init,int width){
  Spinner->set_speed(speed);//変化速度
  Spinner->set_int_limits(min,max,GLUI_LIMIT_CLAMP);//限界値とその処理
  Spinner->set_int_val(init);//初期値
  Spinner->set_w(width);
}


void Listbox_set(GLUI_Listbox *Listbox){
  Listbox->add_item(0,"Solid");
  Listbox->add_item(1,"Wire");
}

void USEorUNUSE(GLUI_Spinner *Spinner,
		GLUI_Listbox *Listbox,GLUI_Checkbox *Checkbox,int display){
  if(display == 1){
    Checkbox->enable();
    Spinner->enable();
    Listbox->enable();
  }else{
    Checkbox->disable();
    Spinner->disable();
    Listbox->disable();
  }
}


void Cluster_Panel(int SVA_D_C_NO, const char* ClusterName){
  GLUI_Rollout *panel = new GLUI_Rollout(Master_glui, ClusterName);
  GLUI_Checkbox *Checkbox_disp = new GLUI_Checkbox(panel,"display",&Cluster_display[SVA_D_C_NO]);
  GLUI_Spinner *SpinnerR = new GLUI_Spinner(panel,"R",&Cluster_RGB[SVA_D_C_NO][0]);
  Spinner_set(SpinnerR,20,0,255,Cluster_RGB[SVA_D_C_NO][0],5);
  GLUI_Spinner *SpinnerG = new GLUI_Spinner(panel,"G",&Cluster_RGB[SVA_D_C_NO][1]);
  Spinner_set(SpinnerG,20,0,255,Cluster_RGB[SVA_D_C_NO][1],5);
  GLUI_Spinner *SpinnerB = new GLUI_Spinner(panel,"B",&Cluster_RGB[SVA_D_C_NO][2]);
  Spinner_set(SpinnerB,20,0,255,Cluster_RGB[SVA_D_C_NO][2],5);
  GLUI_Spinner *Spinner = new GLUI_Spinner(panel,"Alpha",&Cluster_alpha[SVA_D_C_NO]);
  Spinner_set(Spinner,5,0,100,50,7);
  GLUI_Listbox *Listbox = new GLUI_Listbox(panel,"Solid/Wire",&Cluster_list_SW[SVA_D_C_NO]);
  Listbox_set(Listbox);
  GLUI_Checkbox *Checkbox_out = new GLUI_Checkbox(panel,"outline",&Cluster_Outline[SVA_D_C_NO]);
}

void Background_Panel(void){
	GLUI_Rollout *panel = new GLUI_Rollout(Master_glui,"Background");
	GLUI_Spinner *SpinnerR = new GLUI_Spinner(panel,"R",&RGB_Background[0]);
	Spinner_set(SpinnerR,20,0,255,255,10);
	GLUI_Spinner *SpinnerG = new GLUI_Spinner(panel,"G",&RGB_Background[1]);
	Spinner_set(SpinnerG,20,0,255,255,10);
	GLUI_Spinner *SpinnerB = new GLUI_Spinner(panel,"B",&RGB_Background[2]);
	Spinner_set(SpinnerB,20,0,255,255,10);
}

void Option_Panel(void){
	GLUI_Rollout *Optionmenu = new GLUI_Rollout(Master_glui,"Option");
	Master_glui->add_checkbox_to_panel(Optionmenu,"Z-buffering",&check_Zbuffering);
	Master_glui->add_checkbox_to_panel(Optionmenu,"Anti-aliasing (Line)",&check_Antialias_Line);
	Master_glui->add_checkbox_to_panel(Optionmenu,"Anti-aliasing (Polygon)",&check_Antialias_Polygon);
	Master_glui->add_checkbox_to_panel(Optionmenu,"Information",&display_Information);
	Master_glui->add_checkbox_to_panel(Optionmenu,"Debug Moed",&check_DebugMode);
}

void Particle_Panel(void){
	GLUI_Panel *panel = new GLUI_Panel(Master_glui,"Particle");
	
	GLUI_Checkbox *Checkbox_Particle = new GLUI_Checkbox(panel,"Display",&check_Particle);
	GLUI_Checkbox *Checkbox_AccGateNO = new GLUI_Checkbox(panel,"Gated number",&check_AccGateNO);

	{
		using namespace std;
		string MAX_str,MAX_track_str;
		MAX_track_str = Int2String(MAX_track);
		MAX_str = "particle max  :   " + MAX_track_str;
		Master_glui->add_statictext_to_panel(panel,MAX_str.c_str());
	}

	
	GLUI_Spinner *SpinnerTrack = new GLUI_Spinner(panel,"Ungated",&MAX_track);
	Spinner_set(SpinnerTrack,10,0,MAX_track_force,1000,6);

	GLUI_Spinner *SpinnerR = new GLUI_Spinner(panel,"R",&color_All_track_RGB[0]);
	Spinner_set(SpinnerR,20,0,255,255,5);
	GLUI_Spinner *SpinnerG = new GLUI_Spinner(panel,"G",&color_All_track_RGB[1]);
	Spinner_set(SpinnerG,20,0,255,0,5);
	GLUI_Spinner *SpinnerB = new GLUI_Spinner(panel,"B",&color_All_track_RGB[2]);
	Spinner_set(SpinnerB,20,0,255,0,5);
	GLUI_Spinner *SpinnerA = new GLUI_Spinner(panel,"Alpha",&color_All_track_alpha);
	Spinner_set(SpinnerA,5,0,100,70,7);

	GLUI_Spinner *SpinnerW = new GLUI_Spinner(panel,"Width",&Particle_LineWidth);
	Spinner_setF(SpinnerW,1.0,0.0,10.0,1.0,7);

}

void Zaxis_Panel(){
  GLUI_Rollout *panel = new GLUI_Rollout(Master_glui, "Beam line");
  GLUI_Checkbox *Checkbox_disp = new GLUI_Checkbox(panel,"display",&check_Zaxis);
  GLUI_Spinner *SpinnerR = new GLUI_Spinner(panel,"R",&Zaxis_RGB[0]);
  Spinner_set(SpinnerR,20,0,255,Zaxis_RGB[0],5);
  GLUI_Spinner *SpinnerG = new GLUI_Spinner(panel,"G",&Zaxis_RGB[1]);
  Spinner_set(SpinnerG,20,0,255,Zaxis_RGB[1],5);
  GLUI_Spinner *SpinnerB = new GLUI_Spinner(panel,"B",&Zaxis_RGB[2]);
  Spinner_set(SpinnerB,20,0,255,Zaxis_RGB[2],5);
  GLUI_Spinner *Spinner = new GLUI_Spinner(panel,"Alpha",&Zaxis_alpha);
  Spinner_set(Spinner,5,0,100,70,7);
	GLUI_Spinner *SpinnerW = new GLUI_Spinner(panel,"Width",&Zaxis_LineWidth);
	Spinner_setF(SpinnerW,1.0,0.0,10.0,2.0,7);
	GLUI_Spinner *SpinnerS = new GLUI_Spinner(panel,"Scale",&Zaxis_Cons);
	Spinner_setF(SpinnerS,1.0,0.0,100.0,1.0,7);
}

void CloseAbout(int num){
	about_glui->GLUI::close();
}

void MakeAbout(int num){
	using namespace std;
	about_glui = GLUI_Master.create_glui("About",0, 700, 450);
	string AboutName;
	AboutName = AppName;
	about_glui->add_statictext( AboutName.c_str() );
	string AboutVer;
	AboutVer = "   " + AppVer;
	about_glui->add_statictext( AboutVer.c_str() ); 
	string AboutAuth;
	AboutAuth = "             " + AppAuth;
	about_glui->add_statictext( AboutAuth.c_str() ); 

	about_glui->add_statictext( "   " );
	about_glui->add_statictext( " -------------------------------------------------------- " );
	about_glui->add_statictext( "more information ;" );
	about_glui->add_statictext( "       http://be.nucl.ap.titech.ac.jp/~sako/SOLVisualizer/SOLVisualizerANAPAW.html " );
	about_glui->add_button("Exit",0,  CloseAbout);


}

void GUI_glui(void)
{
	using namespace std;
	
	int GLUI_SPINNERINT;
	char *NO_NEUTchar,*NO_NEUT_MODULE;
	
	sub_glui = GLUI_Master.create_glui_subwindow(glutWinId,GLUI_SUBWINDOW_TOP);
	sub_glui->add_statictext( Filename.c_str() ); 
	sub_glui->add_column(1);
	{
		int i;
		GLUI_Listbox *ListboxGate = new GLUI_Listbox(sub_glui,"Gate ID",&Disp_CurrentGate);
		for (i=1 ; i <= Disp_GateMAX ; i++){
			string GateName;
			GateName = Int2String(Disp_GateList[i]);
			ListboxGate->add_item(Disp_GateList[i],GateName.c_str());
		}
	}
	sub_glui->add_column(1);

	//	editText = new GLUI_EditText( sub_glui, "Text:", text_glui_str, -1, editTextCB );
	//	sub_glui->add_edittext("png",GLUI_EDITTEXT_TEXT,*pngname);
	//	sub_glui->add_column(0);
	sub_glui->add_button("Save as .png ( p )", 0, gluiCallbackPng);
	sub_glui->add_column(0);
	sub_glui->add_button("initialize ( i )",0,  initialize);
	sub_glui->add_column(0);
	sub_glui->add_button("Exit ( ESC or q )", 0, gluiCallbackExit);
	sub_glui->add_column(0);
	sub_glui->set_main_gfx_window(glutWinId);
	sub_glui->add_column(1);
	sub_glui->add_button("About", 0, MakeAbout);


	
	Master_glui = GLUI_Master.create_glui_subwindow(glutWinId,GLUI_SUBWINDOW_RIGHT);

	//	GLUI *glui = GLUI_Master.create_glui_subwindow(glutWinId,GLUI_SUBWINDOW_RIGHT);
	GLUI_Master.set_glutDisplayFunc(display);//displayはglut
	GLUI_Master.set_glutReshapeFunc(reshape);//gluiで登録
	GLUI_Master.set_glutKeyboardFunc(keyboard);//gluiで登録
	GLUI_Master.set_glutSpecialFunc(Specialkeyboard);//gluiで登録
	GLUI_Master.set_glutMouseFunc(myMouseFunc);//gluiで登録
 //	GLUI_Master.set_glutIdleFunc(FPS);//gluiで登録
	
	
	int PreDetCluNO = 0;
	for (int i = 0 ; i < MAX_Detector ; i++){
		if (SVA_DetectorClusterNO[i]  != PreDetCluNO ){
			string ClusterName;
			map<int, string>::iterator itr = ClusterMap.begin();
			// キーから値を検索
			itr = ClusterMap.find(SVA_DetectorClusterNO[i]);
			// マップが end では無い場合（つまりキーにヒットする値が存在した場合）
			if (itr != ClusterMap.end()) 
				{
				// 値取得
					ClusterName = itr->second;
				}
			Cluster_Panel(SVA_DetectorClusterNO[i], ClusterName.c_str());
		}
		PreDetCluNO = SVA_DetectorClusterNO[i];
	}

	Master_glui->add_column(true);

	GLUI_Panel *Controlpanel = new GLUI_Panel(Master_glui,"",GLUI_PANEL_NONE);
	Master_glui->add_translation_to_panel(Controlpanel,"XY",GLUI_TRANSLATION_XY,trans_ary);
	Master_glui->add_column_to_panel(Controlpanel,0);
	Master_glui->add_translation_to_panel(Controlpanel,"Z",GLUI_TRANSLATION_Z,trans_aryZ);
	//	Master_glui->add_rotation_to_panel(Controlpanel,"rotation",rotary,-1,rotCB);

	Master_glui->add_separator();

	Particle_Panel();
	Background_Panel();
	Zaxis_Panel();
	Option_Panel();
	
	Master_glui->add_separator();
	GLUI_Panel *Keypanel = new GLUI_Panel(Master_glui,"Keyboard");
	Master_glui->add_statictext_to_panel(Keypanel, "Move : arrow key");
	//Master_glui->add_statictext_to_panel(Keypanel, "Fast Move : Shit + arrow key");
	Master_glui->set_main_gfx_window(glutWinId);
}



int MultimapTest(std::vector<float> next){
	typedef std::pair<int, float> distMap;
	std::multimap<int, int> mMap; //昇順にソートするときはgreater<int>を引数に加える。
	std::multimap<int, float> MMapSort;
	int j =0;
	int counter=0;
	for(std::vector<float>::iterator it = next.begin(); it != next.end(); ++it)
		{
			//printf("%d:%d\n", counter, *it);
			MMapSort.insert( distMap( *it, counter)) ;
			counter++;
		}
	
	printf("=====================================\n");
	
	for(std::multimap<int,float>::iterator it = MMapSort.begin(); it != MMapSort.end(); ++it){
		std::cout << (*it).first << (*it).second <<std::endl;
		//			printf("%f:%f\n", (*it).first, (*it).second);
	}
	
	return MMapSort.begin()->first; //@tmytさんに突っ込まれたところ。
}



	

void LoadTracking(const char *FilenameTraChar, float **track){
	using namespace std;
	int i;
	i = 0;
	{
		ifstream ifs( FilenameTraChar);
		if(not(ifs)){
			cout << FilenameTraChar << " Can not open file !! \n "<< endl;
			gluiCallbackExit(0);
		}
		if(ifs){
			while(!ifs.eof() && i < MAX_track_force){
				ifs >> SVA_EventCounter[i] >> track[i][0] >> track[i][1] >> track[i][2] >> All_track_T[i] ;
				if (check_DebugMode == 1){
					cout << i << "," << SVA_EventCounter[i] << "," <<track[i][0] << "," 
							 << track[i][1] << "," << track[i][2] << "," << All_track_T[i] << endl; 
				}
 				i++;
			}
			MAX_track = i - 1;
		}
	}
	
	//	SortTracking();
}

void MakeTracking(){
	using namespace std;
	string FilenameTra;
	
	FilenameTra = Filename + ".tra";
	cout << "Tracking File : " << FilenameTra << endl;
	
	LoadTracking(FilenameTra.c_str(),All_track);
	//  load_tra(trafilecha,All_track,0);
}


void LoadDetector(const char *FilenameDetChar){
	using namespace std;
	//char shape[2],dummy[3];
	//	float position_x,position_y,position_z,width,height,depth;
	float Detector_geo_raw[2000][6];
	FILE *fp;
	int i ;
	
	{
		ifstream ifs( FilenameDetChar);
		if(not(ifs)){
			cout << FilenameDetChar << " Can not open file !! \n "<< endl;
			gluiCallbackExit(0);
		}
		if(ifs){
			ifs >> SVA_ClusterNOMax;
			if ( check_DebugMode  == 1){
				cout << SVA_ClusterNOMax << endl;
			}
			for (i = 0 ; i< SVA_ClusterNOMax ; i++){
				ifs >> SVA_ClusterNO[i] ;
				if ( check_DebugMode  == 1){
					cout << SVA_ClusterNO[i] << endl ;
				}
			}
			string str_temp;
			for (i = 0 ; i< SVA_ClusterNOMax ; i++){
				ifs >> str_temp ;
				if (check_DebugMode == 1 ) {
					cout << str_temp << endl ;
				}
				ClusterMap.insert( map<int, string>::value_type( SVA_ClusterNO[i], str_temp ) );
			}
			i = 0;
			while(!ifs.eof()){
				ifs >> SVA_DetectorID[i] >> SVA_DetectorClusterNO[i] >> Detector_geo[i][0] >>
					Detector_geo[i][1] >> Detector_geo[i][2] >> Detector_geo[i][3] >>
					Detector_geo[i][4] >> Detector_geo[i][5] ;

				if (check_DebugMode == 1){
					cout << i << "," << SVA_DetectorID[i] << "," << SVA_DetectorClusterNO[i] << "," <<
						Detector_geo[i][0] << "," << Detector_geo[i][1] << "," << 
						Detector_geo[i][2] << "," << Detector_geo[i][3] << "," <<
						Detector_geo[i][4] << "," << Detector_geo[i][5] << "," <<endl;
				}
				i++;
			}
			if (SVA_DetectorID[i] == 0){
				i--;
			}
			MAX_Detector = i;
		}
	} 
	if (check_DebugMode == 1) {
		cout << "MAX_Detector : " << MAX_Detector << endl;
	}
}	
	

void MakeDetector(){
	using namespace std;
	string FilenameDet;

	FilenameDet = Filename + ".det";
	cout << "Detector File : " << FilenameDet << endl;
	
	LoadDetector(FilenameDet.c_str());
}


void MakeDispGate(int num){
	int i;
	for ( i = 0 ; i <= Disp_GateMAX  ; i++){
		if ( num == Disp_GateList[i] ){
			i = 0;
			break;
		}
	}
	if (i == Disp_GateMAX +1){
		Disp_GateList[i] = num;
		Disp_GateMAX += 1;
	}
}


void LoadGate(const char *FilenameGateChar){
	using namespace std;
	int i,j;
	{
		ifstream ifs( FilenameGateChar);
		if(not(ifs)){
			cout << FilenameGateChar << " Can not open file !! \n "<< endl;
			gluiCallbackExit(0);
		}
		if(ifs){
			i = 0;
			Disp_GateMAX = 1;
			for ( i = 0; i <MAX_track ; i++){
				if (!ifs.eof()){
					ifs >> EC_GateList[i] >> NO_GateList[i] ;
					Track_GateList[i][0] = 0;
						for (j = 1 ; j <= NO_GateList[i] ; j++){
							ifs >> Track_GateList[i][j] ;
							MakeDispGate(Track_GateList[i][j]);
						}
						GateMap.insert( map<int, int*>::value_type( EC_GateList[i], Track_GateList[i] ) );
						GateMaxMap.insert( map<int, int>::value_type( EC_GateList[i], NO_GateList[i] ) );
				}
			}

//			if (check_DebugMode == 1){
//				for ( i = 0; i <MAX_track ; i++){
//					cout << EC_GateList[i] << "," << NO_GateList[i]  ;
//					for (j = 0 ; j <= NO_GateList[i] ; j++){
//						cout << "," << Track_GateList[i][j] ;
//					}
//					cout << endl;
//				}
//			}
		}
	}

//	if (check_DebugMode == 1){
//		cout << Disp_GateMAX  << endl ;
//		for (i = 1 ; i <= Disp_GateMAX ; i++){
//			cout << "," << Disp_GateList[i] ;
//		}
//		cout << endl ;
//	}
	
}			

void MakeGate(){
	using namespace std;
	string FilenameGate;
	
	FilenameGate = Filename + ".glt";
	cout << "Gate File : "<< FilenameGate << endl;
	
	LoadGate(FilenameGate.c_str());
}


void MakeFilename(const char *RDFNAME, const char *ANAFNAME){
	using namespace std;

	if (RDFNAME == "Default"){
		FILE *fp;
		const char *CurrentFILE;
		string filename_org;
		int filename_org_size;

		CurrentFILE = "./src/SVA/result/SVACurrentStatus.txt";

		{
			ifstream ifs( CurrentFILE );
			if(not(ifs)){
				cout << CurrentFILE << " Can not open file !! \n "<< endl;
				gluiCallbackExit(0);
			}
			if(ifs){
				getline(ifs, filename_org);
				boost::trim(filename_org);
			}
		} 
		filename_org_size = filename_org.size() - 4;
		Filename = filename_org.substr( 0, filename_org_size );
		//		Filename =  Filename;
	}
	cout << "Current File : " << Filename <<  endl;
}


void load_filename(void){
	using namespace std;
  FILE *fp;
	int i ,ret;

  fp = fopen("config_SOLVisualizer", "r" );
  if( fp == NULL ){
    printf( "config_SOLVisalizer : Can not open file !! ¥n");
		gluiCallbackExit(0);
  }
	fscanf( fp, "%s %d %d", filename, &WindowSize.first,&WindowSize.second);
	fclose( fp );
}

void capture(const char *filepath,int Flag)
{
	    //const char filepath[] = "./output.png";
	    //const char *filepath = "./output.png";
    
	png_bytep raw1D;
    png_bytepp raw2D;
    int i;
    int width = glutGet(GLUT_WINDOW_WIDTH);
    int height = glutGet(GLUT_WINDOW_HEIGHT);

     //構造体確保
    FILE *fp = fopen(filepath, "wb");
    png_structp pp = png_create_write_struct(PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);
    png_infop ip = png_create_info_struct(pp);
    // 書き込み準備
    png_init_io(pp, fp);
    png_set_IHDR(pp, ip, width, height,
        8, // 8bit以外にするなら変える
        PNG_COLOR_TYPE_RGBA, // RGBA以外にするなら変える
        PNG_INTERLACE_NONE, PNG_COMPRESSION_TYPE_DEFAULT, PNG_FILTER_TYPE_DEFAULT);
     //ピクセル領域確保
    raw1D = (png_bytep)malloc(height * png_get_rowbytes(pp, ip));
    raw2D = (png_bytepp)malloc(height * sizeof(png_bytep));
    for (i = 0; i < height; i++)
        raw2D[i] = &raw1D[i*png_get_rowbytes(pp, ip)];
     //画像のキャプチャ
    glReadBuffer(GL_FRONT);
    glPixelStorei(GL_UNPACK_ALIGNMENT, 1); // 初期値は4
    glReadPixels(0, 0, width, height,
            GL_RGBA, // RGBA以外にするなら変える
            GL_UNSIGNED_BYTE, // 8bit以外にするなら変える
            (void*)raw1D);
     //上下反転
    for (i = 0; i < height/ 2; i++){
        png_bytep swp = raw2D[i];
        raw2D[i] = raw2D[height - i - 1];
        raw2D[height - i - 1] = swp;
    }
     //書き込み
    png_write_info(pp, ip);
    png_write_image(pp, raw2D);
    png_write_end(pp, ip);
     //開放
    png_destroy_write_struct(&pp, &ip);
    fclose(fp);
    free(raw1D);
    free(raw2D);
		
		if (Flag == 1){
			printf("write out screen capture to '%s'\n", filepath);
		}
}









/*
** シーンの描画
*/
void  scene(void)
{
  	glPushMatrix();

  /* テクスチャマッピング開始 */
  glEnable(GL_TEXTURE_2D);

  /* アルファテストを有効にする */
  glEnable(GL_ALPHA_TEST);


  /* パーティクルを描く */
   glMultMatrixf( &quatm[0][0] );
  glColor3d(1.0, 1.0, 1.0);
  glBegin(GL_POINTS);
glVertex3f(1,1,-1);	
glVertex3f(0,0,1);	
  //glTranslated(100.0, 100.0, 0.0);
  glEnd();
  	glPopMatrix();

//    glBegin(GL_POINTS);

//  glEnd();

  /* アルファテストを無効にする */
  glDisable(GL_ALPHA_TEST);

  /* テクスチャマッピング終了 */
  glDisable(GL_TEXTURE_2D);
}


/****************************
** GLUT のコールバック関数 **
****************************/


static void display2(void)
{
  /* モデルビュー変換行列の初期化 */
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  
  /* 光源の位置を設定 */
  //glLightfv(GL_LIGHT0, GL_POSITION, lightpos);
  
  /* 視点の移動（物体の方を奥に移動）*/
  glTranslated(0.0, 0.0, -3.0);
  
  
  /* 画面クリア */
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
  /* シーンの描画 */
  build_rotmatrix(quatm, curquat);
  //scene();
geometry();

  /* ダブルバッファリング */
  glutSwapBuffers();
}





int main(int argc, char *argv[])
{

	using namespace std;
	int i;
	const char *RDFNAME,*ANAFNAME;
	//	cout << i << flush << endl ;
	Init_Array();

	// for loaddetWindows
	//	load_filename();

	// for Linux

	if (argv[0] == "-debug"){
		check_DebugMode = 1;
	}

	switch(argc)
		{
		case 0:
			RDFNAME = "Default";
			break;
		case 1:
			RDFNAME = "Default";
			break;
		case 2:
			RDFNAME = argv[1];
			ANAFNAME = argv[2];
			break;
		}
	
	//	filename = argv[1];
	//	if (argc == 3){
	//		WindowSize.first =  atoi(argv[2]);
	//	}
	//	if (argc == 4){
	//		WindowSize.first =  atoi(argv[2]);
	//		WindowSize.second = atoi(argv[3]);
	//		}

	MakeFilename(RDFNAME,ANAFNAME);
	trackball(curquat, 0.0, 0.0, 0.0, 0.0);
 	MakeDetector();
	MakeTracking();
	MakeGate();
	GLUT_INITs(&argc, argv);
	GUI_glui();

	// glutInit(&argc, argv);
	// glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH | GLUT_DOUBLE);
	//glutCreateWindow(argv[0]);
	//	  Texture_init();
	// glutDisplayFunc(display);
	//glutReshapeFunc(resize);
	glutMainLoop();
	return 0;
}

