c
c
      SUBROUTINE ENC_Sample(raw_T, nwrd_T, raw_A, nwrd_A, 
     &                             val,nx,ny,naok,Rnum)
      IMPLICIT NONE
c 
c Analyzer '1'
c
c -----------------------------------------------------------------------------
c ID:     
c     1 - 5 : NEBULA NEUT
c     6, 7  : NEBULA VETO 1, 2
c     8     : START COUNTER
c     11-13 : HIME NEUT
c     14    : HIME VETO
c
c W#:  1      2          3         4         5        6       7         8      
c      ID     TLraw      TRraw     <T>raw    dTraw    ALraw   ARraw     <A>raw  
c             [ch]       [ch]      [ch]      [ch]     [ch]    [ch]      [ch]
c
c =============================================================================
c

      INCLUDE 'nebula.inc'
      INCLUDE '../SVA/SVAvaliable.inc'

c inputs
      INTEGER   nwrd_T, nwrd_A
      INTEGER*2 raw_T(nwrd_T),raw_A(nwrd_A)
      integer*4 iev(2,3)
      INTEGER   nx,ny,naok
      REAL      val(nx,ny)
      INTEGER   ihit_min0
      save      ihit_min0
      INTEGER   Rnum

c  DO not EDIT!!
      CHARACTER IHITCHARA*4
      LOGICAL   AnalyserFlag(50),INITENCFLAG(50)
      LOGICAL   USERFLAG(10),EVTERR
      COMMON/ANALYSLOGIC/ AnalyserFlag,INITENCFLAG,USERFLAG,EVTERR 
c  DO not EDIT!!

      INTEGER   ihit_nebula(nch_nebula)
      REAL      data_nebula(4,nch_nebula)

      INTEGER   id,i

      Integer   WallID
      Integer   ClusterID
      Real      c_light
      parameter ( c_light = 29.9792458 ) ! cm/ns

      REAL      dumdata
      PARAMETER (dumdata=-2000.)
 
c---------------------------------------------------------------------- 


      
c -------------
c Begin
c -------------

      IF(InitENCFlag(1)) THEN   !read calibrations
         Call NEBULA_PRM(Rnum)
         Call SVAPosition_prm
     &        (Rnum,
     &        SVA_ClusterNOMax,SVA_ClusterNO,SVA_ClusterName,
     &        SVA_DetectorCluster)
         
         InitENCFlag(1) = .FALSE.
         
         call SVAEnviromentSet
     &        (SVA_DetectorFile,SVA_TrackingFile,
     &        SVA_ClusterNOMax,SVA_ClusterNO,SVA_ClusterName,
     &        SVA_DetectorCluster)

         DO id = 1, nch_nebula
            call SVADetectorSet
     &           (SVA_DetectorFile, id, SVA_DetectorCluster,
     &           x_center(id),y_center(id),z_center(id),
     &           x_length(id),y_length(id),z_length(id))
         ENDDO
      ENDIF



c --------------
c initialization
c --------------
c      write(*,*) 'initialization start'

      call SVAStartLoop()

      naok = 0

      DO id=1,nch_nebula

c 
c analysis ,,,,,,,,,

c ------------------
c Position
c ------------------

         IF(Tflag(id).AND. Aflag(id))THEN
            call SVAParticleWrite
     &           (SVA_TrackingFile,
     &           x_position(id),y_position(id),z_position(id),
     &           T_slew(id))
         ENDIF

      ENDDO

c
c ------------------------------------------------------------------------------------------------
c ---------------------
c Input val
c ---------------------
c
      DO id = 1,nch_nebula
         naok = naok + 1


         val(2,naok) = TLraw(id)
         val(3,naok) = TRraw(id)
      ENDDO

      RETURN
      END
